/**
  ******************************************************************************
  * File Name          : 
  * Description        :
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2020 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __EC801_H
#define __EC801_H
#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "app.h"



#define TX_RX_STAT_IDLE 0
#define TX_RX_STAT_BUSY 1

#define TimeOut_OFF 0
#define TimeOut_ON  1

typedef struct M4G_FSM_s
{
    uint8_t     eCurrStat;  //ǰ̬
    uint8_t      TxRxStat;  //ͽ״̬
    uint8_t        txStep;  //Ͳ
    uint8_t       endStep;  //ƽ̨
    uint8_t      retryCnt;  //ط
    uint8_t     eTimeStat;  //ʱ״̬
    uint32_t    rxTimeout;  //ճʱ
    uint32_t    tickStart;  //ʼ
    uint8_t       stepCnt;  //ɹ
    uint8_t       sendCnt;  //ѭ
} M4G_FSM_t;

typedef struct app_ec801_s
{
    uint8_t                       csq; /* źǿ */
} AppEc801_t; //Ϣ

#define M4G_STAT_CONNECT_RESTART        0 //ģϵ
#define M4G_STAT_CONNECT_START          1 //ȴģ׼
#define M4G_STAT_CONNECT_BASE_STATION   2 //ӻվ--CREGע״̬
#define M4G_STAT_HTTPS_CFG              3 //HTTPS--QHTTPCFG
#define M4G_STAT_HTTPS_ACTIVE           4

#define M4G_STAT_CONNECT_PLATFORM       5 //ƽ̨--CONNECT
#define M4G_STAT_DATA_PASS_THROUGH      6 //͸
#define M4G_STAT_DATA_BREAK_THROUGH     7 //͸

#define ContextID 1

typedef enum
{
    // AT_RESET = 0,
    // AT_POWDOWN=0,
    AT_DELAY = 0,
    AT_TEST,
    AT_ATE0,
    AT_CGSN,
    AT_CSQ,
    AT_CPIN,
    AT_CREG,
    AT_CGATT,
    AT_QIDEACT,
    AT_QIACT,
    AT_DNS_ANALY,

    AT_DESTROY,
    AT_QICLOSE_ID,
    AT_QIDEACT_ID,

    AT_QHTTPCFG,
    // AT_QSSLCFG,
    AT_QHTTPURL,
    AT_QHTTPCONN,
    AT_QHTTPGET,
    AT_QHTTPREAD,

    AT_QMTOPEN,
    AT_QMTCONN,
    AT_QMTPUBEX,
    AT_MQTT_TX,
    AT_QMTDISC,

    AT_OPEN_ID,
    AT_DEOPEN,


        
    AT_MAX,
}EC801_NUM;

typedef struct{
    char        *pATSendStr;    //͵ATַָ
    char        *pATRecStr;     //յATӦַ
    char        *pDescribe;     //Եǰָ
    uint32_t    TimeOut;        //ȴʱʱ
    uint8_t     retryNum;       //Դ

}ATCMD_str;


void AppCAT1_Task(void);
void AppCAT1_Init(void);

void NET_M4G_Reset(void);
void EC600_Connet_TCP(void);

void EC801_Connet_MQTT(void);

void EC600_DNS_Analysis(void);
void M4G_GetIPAddress(void);
void M4G_GetSignalStrength(void);
uint8_t TCP_RecvPassThrough(void);
void TCP_Read_Buff(uint8_t *buf);
void TCP_Write_bUFF(uint8_t *buf, uint32_t len);
uint8_t BSP_UART_RX(char *pdata,uint64_t timeout);
void AppM4G_Task(void);
void AppM4G_Init(void);


#ifdef __cplusplus
}
#endif
#endif /*__ pinoutConfig_H */

/**
  * @}
  */

/**
  * @}
  */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
